{
  pkgs,
  zen,
  config,
  ...
}:
{
  # Module imports
  imports = [
    # Common Modules
    ../../../common/home
    ../../../common/git
    ../../../common/vscode

    # Modules
    ../modules/fleet/home.nix
    ../modules/gnome/home.nix
    ../modules/vm/home.nix
  ];

  # ssh
  programs.ssh = {
    enable = true;
    matchBlocks = {
      "git.ryot.foo" = {
        identityFile = "~/git/.ssh/git";
      };
    };
    extraConfig = ''
    IdentityFile ~/.ssh/pve
    '';
  };

  # Enables app shorcuts
  targets.genericLinux.enable = true;
  xdg.mime.enable = true;
  xdg.systemDirs.data = [ "${config.home.homeDirectory}/.nix-profile/share/applications" ];

  home.packages = with pkgs; [
    bitwarden-desktop
    chafa
    fastfetch
    fish
    fishPlugins.grc
    fishPlugins.tide
    gpu-screen-recorder-gtk
    grc
    jetbrains-toolbox
    inspector
    logisim-evolution
    mcaselector
    monocraft
    nerd-fonts.fira-code
    nodejs_22
    pnpm
    prettierd
    prismlauncher
    spotify
    telegram-desktop
    termius
    vesktop
    vivaldi
    zen
  ];
}
